package com.thebrokenrail.sorcerycraft.spell;

import com.thebrokenrail.sorcerycraft.spell.registry.Spell;
import net.minecraft.entity.Entity;
import net.minecraft.entity.LivingEntity;
import net.minecraft.entity.effect.StatusEffects;
import net.minecraft.item.ItemStack;
import net.minecraft.item.Items;
import net.minecraft.util.Identifier;

public class HealSpell extends Spell {
    public HealSpell(Identifier id, int level) {
        super(id, level);
    }

    @Override
    public void execute(Entity target, Entity source, Entity attacker) {
        if (target instanceof LivingEntity) {
            StatusEffects.INSTANT_HEALTH.applyInstantEffect(source, attacker, (LivingEntity) target, getLevel(), 1.0d);
        }
    }

    @Override
    public int getXPCost() {
        switch (getLevel()) {
            case 0: {
                return 5;
            }
            case 1: {
                return 10;
            }
        }
        return -1;
    }

    @Override
    public ItemStack getItemCost() {
        switch (getLevel()) {
            case 0: {
                return ItemStack.EMPTY;
            }
            case 1: {
                return new ItemStack(Items.GHAST_TEAR);
            }
        }
        return ItemStack.EMPTY;
    }

    @Override
    public int getMaxLevel() {
        return 2;
    }
}
